#include "sysconfig.h"
#include "sysdeps.h"
#include "config.h"

#include "uae.h"
#include "options.h"
#include "menu.h"
#include "menu_config.h"
#include "sound.h"
#include "disk.h"
#include "memory-uae.h"
#include "custom.h"
#include "xwin.h"
#include "drawing.h"

extern int screenWidth;
extern int mainMenu_case;

extern int lastCpuSpeed;
extern int ntsc;

extern char launchDir[300];
extern char currentDir[300];

int saveAdfDir()
{
	char path[300];
	snprintf(path, 300, "%s/conf/adfdir.conf", launchDir);
	FILE *f=fopen(path,"w");
	if (!f) return 0;
	char buffer[310];
	snprintf((char*)buffer, 310, "path=%s\n",currentDir);
	fputs(buffer,f);
	fclose(f);
	return 1;
}


void extractFileName(char * str,char *buffer)
{
	char *p=str+strlen(str)-1;
	while(*p != '/')
		p--;
	p++;
	strcpy(buffer,p);
}


void update_display()
{
	char layersize[20];
	snprintf(layersize, 20, "%dx480", screenWidth);
	setenv("SDL_OMAP_LAYER_SIZE",layersize,1);
	char bordercut[20];
//	snprintf(bordercut, 20, "%d,%d,0,%d", mainMenu_cutLeft, mainMenu_cutRight, 270-mainMenu_displayedLines);
	snprintf(bordercut, 20, "%d,%d,0,0", mainMenu_cutLeft, mainMenu_cutRight);
	setenv("SDL_OMAP_BORDER_CUT",bordercut,1);
	
#ifdef ANDROIDSDL
	if (mainMenu_case != MAIN_MENU_CASE_DISPLAY && mainMenu_case != MAIN_MENU_CASE_MEMDISK && mainMenu_onScreen==0) SDL_ANDROID_SetScreenKeyboardShown(0);
	else SDL_ANDROID_SetScreenKeyboardShown(1);
#endif
	
#ifdef PANDORA
//	prSDLScreen = SDL_SetVideoMode(visibleAreaWidth, 270, 16, SDL_SWSURFACE|SDL_FULLSCREEN|SDL_DOUBLEBUF);
	prSDLScreen = SDL_SetVideoMode(visibleAreaWidth, mainMenu_displayedLines, 16, SDL_SWSURFACE|SDL_FULLSCREEN|SDL_DOUBLEBUF);
#else
	prSDLScreen = SDL_SetVideoMode(visibleAreaWidth, mainMenu_displayedLines, 16, SDL_SWSURFACE|SDL_FULLSCREEN);
#endif
  SDL_ShowCursor(SDL_DISABLE);

	if(mainMenu_displayHires)
		InitDisplayArea(visibleAreaWidth >> 1);
	else
		InitDisplayArea(visibleAreaWidth);
}


void setCpuSpeed()
{
	char speedCmd[128];

	if(mainMenu_cpuSpeed != lastCpuSpeed)
	{
		snprintf((char*)speedCmd, 128, "unset DISPLAY; echo y | sudo -n /usr/pandora/scripts/op_cpuspeed.sh %d", mainMenu_cpuSpeed);
		system(speedCmd);
		lastCpuSpeed = mainMenu_cpuSpeed;
	}
	if(mainMenu_ntsc != ntsc)
	{
		ntsc = mainMenu_ntsc;
		if(ntsc)
			system("sudo /usr/pandora/scripts/op_lcdrate.sh 60");
		else
			system("sudo /usr/pandora/scripts/op_lcdrate.sh 50");
	}
	update_display();
}
