#include <algorithm>
#ifdef ANDROIDSDL
#include <android/log.h>
#endif
#include <guichan.hpp>
#include <iostream>
#include <sstream>
#include <SDL/SDL_ttf.h>
#include <guichan/sdl.hpp>
#include <guichan/contrib/sdl/sdltruetypefont.hpp>

#include "sysconfig.h"
#include "sysdeps.h"
#include "config.h"

#include "menu.h"
#include "menu_config.h"
#include "gui.h"


namespace widgets
{
  static void unraise_Message();

  extern gcn::Color baseCol;

  gcn::Window *window_warning;
  gcn::Button* button_warning;
  gcn::Label* label_text;
  

  class WarningButtonActionListener : public gcn::ActionListener
  {
    public:
      void action(const gcn::ActionEvent& actionEvent)
      {
    		unraise_Message();
      }
  };
  WarningButtonActionListener* warningButtonActionListener;
  
  
  void menuMessage_Init()
  {
  	button_warning = new gcn::Button(" Ok ");
  	button_warning->setPosition(70,30);
    button_warning->setSize(70, 26);
    button_warning->setBaseColor(baseCol);
    warningButtonActionListener = new WarningButtonActionListener();
  	button_warning->addActionListener(warningButtonActionListener);

  	label_text = new gcn::Label("                  Warning                  ");
    label_text->setPosition(4, 4);
    
  	window_warning = new gcn::Window("Warning");
  	window_warning->add(button_warning);
	  window_warning->add(label_text);
  	window_warning->setMovable(false);
  	window_warning->setSize(200,80);
    window_warning->setBaseColor(baseCol);
    window_warning->setVisible(false);
  }


  void menuMessage_Exit()
  {
		delete button_warning;
  	delete label_text;

  	delete warningButtonActionListener;
  	
  	delete window_warning;
  }


  static void unraise_Message()
  {
    window_warning->releaseModalFocus();
    window_warning->setVisible(false);
  }


  void showInfo(const char *msg)
  {
	  label_text->setCaption(msg);
    window_warning->setCaption("Information");
    window_warning->setVisible(true);
    window_warning->requestModalFocus();
  }


  void showWarning(const char *msg)
  {
	  label_text->setCaption(msg);
    window_warning->setCaption("Warning");
    window_warning->setVisible(true);
    window_warning->requestModalFocus();
  }


  void show_error(const char *msg)
  {
	  label_text->setCaption(msg);
    window_warning->setCaption("Error");
    window_warning->setVisible(true);
    window_warning->requestModalFocus();
  }

}
